table.insert( actions,
{
	id          = "EEM_BLOOD_FOR_MANA",
	name 		= "Haemomancy",
	description = "Use HP instead of Mana to cast the next spell.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/blood_mana.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 50,
	mana = 0,
    action 		= function()
        c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_purple.xml,"
        draw_action_eem(true, true, false)
	end,
} )

table.insert( actions,
{
	id          = "EEM_GOLD_FOR_MANA",
	name 		= "Auromancy",
	description = "Use Gold instead of Mana to cast the next spell.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/gold_mana.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 10,
	mana = 0,
    action 		= function()
        c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_yellow.xml,"
        draw_action_eem(true, false, true)
	end,
} )

table.insert( actions,
{
	id          = "EEM_BLOOD_FOR_SPEED",
	name 		= "Quickened Pulse",
	description = "Use HP to significantly boost the recharge rate of your spells.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/blood_speed.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 120,
	mana = 0,
    action 		= function()
        if(take_blood_if_affordable(0.1)) then
            c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_yellow.xml,"
            c.fire_rate_wait    = math.max(0, c.fire_rate_wait - 20)
            current_reload_time = math.max(0, current_reload_time - 40)
            draw_action_eem(true, false, false)
        end
	end,
} )

table.insert( actions,
{
	id          = "EEM_GOLD_FOR_SPEED",
	name 		= "Time = Money",
	description = "Use Gold to significantly boost the recharge rate of your spells.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/gold_speed.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 35,
	mana = 0,
    action 		= function()
        if(take_gold_if_affordable(1)) then
            c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_yellow.xml,"
            c.fire_rate_wait    = math.max(0, c.fire_rate_wait - 20)
            current_reload_time = math.max(0, current_reload_time - 40)
            draw_action_eem(true, false, false)
        end
	end,
} )

table.insert( actions,
{
	id          = "EEM_BLOOD_FOR_DAMAGE",
	name 		= "Adrenaline",
	description = "Use HP to significantly boost the damage of your spells.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/blood_dmg.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 80,
	mana = 0,
    action 		= function()
        if(take_blood_if_affordable(2.5)) then
            c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_red.xml,"
            c.damage_projectile_add = c.damage_projectile_add + 0.8
			c.gore_particles    = c.gore_particles + 25
            draw_action_eem(true, false, false)
        end
	end,
} )

table.insert( actions,
{
	id          = "EEM_GOLD_FOR_DAMAGE",
	name 		= "Contract Killer",
	description = "Use Gold to significantly boost the damage of your spells.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/gold_dmg.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 40,
	mana = 0,
    action 		= function()
        if(take_gold_if_affordable(2)) then
            c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_orange.xml,"
            c.damage_projectile_add = c.damage_projectile_add + 0.8
			c.gore_particles    = c.gore_particles + 25
            draw_action_eem(true, false, false)
        end
	end,
} )

table.insert( actions,
{
	id          = "EEM_BLOOD_FOR_FIRE",
	name 		= "Heartburn",
	description = "Use HP to add powerful trails of flame to your spells.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/blood_fire.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 90,
	mana = 0,
    action 		= function()
        if(take_blood_if_affordable(0.75)) then
            c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_red.xml,data/entities/misc/burn.xml,data/entities/misc/burn.xml,"
            c.game_effect_entities = c.game_effect_entities .. "data/entities/misc/effect_apply_on_fire.xml,"
            c.trail_material = c.trail_material .. "fire,"
            c.trail_material_amount = c.trail_material_amount + 30
            draw_action_eem(true, false, false)
        end
	end,
} )

table.insert( actions,
{
	id          = "EEM_GOLD_FOR_ACID",
	name 		= "Aqua Regia",
	description = "Use Gold to add powerful trails of acid and gas to your spells.",
	sprite 		= "mods/exchange_modifiers/files/ui_gfx/gold_acid.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "0,1,2,3,4,5,6,7", -- BERSERK_FIELD
	spawn_probability                 = "1,1,1,1,1,1,1,1", -- BERSERK_FIELD
	price = 15,
	mana = 0,
    action 		= function()
        if(take_blood_if_affordable(5)) then
            c.extra_entities = c.extra_entities .. "data/entities/particles/tinyspark_yellow.xml,"
            c.trail_material = c.trail_material .. "acid,acid_gas"
            c.trail_material_amount = c.trail_material_amount + 15
            draw_action_eem(true, false, false)
        end
	end,
} )

function take_blood_if_affordable( cost )
    local player_entity = EntityGetClosestWithTag( pos_x, pos_y, "player_unit")
    local damagemodels = EntityGetComponent( player_entity, "DamageModelComponent" )
    if( damagemodels ~= nil ) then
        for i,damagemodel in ipairs(damagemodels) do
            local hp = tonumber( ComponentGetValue( damagemodel, "hp" ) * 25)
            if(cost > (hp + 1) or (hp < 1)) then
                return false
            else
                local new_hp = (hp - cost)
                ComponentSetValue( damagemodel, "hp", new_hp / 25 )
            end
        end
    end

    return true
end

function take_gold_if_affordable( cost )
    local player_entity = EntityGetClosestWithTag( pos_x, pos_y, "player_unit")
    local wallet_comp = EntityGetFirstComponent( player_entity, "WalletComponent" )

	if( wallet_comp ~= nil ) then 
        money_now = tonumber( ComponentGetValue( wallet_comp, "money" ) )
        
        if(cost > money_now) then
            return false
        else
            local new_money = (money_now - cost)
            ComponentSetValue(wallet_comp, "money", new_money)
        end
	end

    return true
end

function draw_action_eem(instant_reload_if_empty, use_blood_for_mana, use_gold_for_mana)
	local action = nil

	state_cards_drawn = state_cards_drawn + 1

	if reflecting then  return  end


	if ( #deck <= 0 ) then
		if instant_reload_if_empty then
			move_discarded_to_deck()
			order_deck()
			start_reload = true
		else
			reloading = true
			return true -- <------------------------------------------ RETURNS
		end
	end

	if #deck > 0 then
		-- draw from the start of the deck
		action = deck[ 1 ]

        table.remove( deck, 1 )
        
        if action.uses_remaining == 0 then
			table.insert( discarded, action )
			return false -- <------------------------------------------ RETURNS
        end

		-- update mana
		local action_mana_required = action.mana
		if action.mana == nil then
			action_mana_required = ACTION_MANA_DRAIN_DEFAULT
        end

        if action_mana_required > mana and use_blood_for_mana == false and use_gold_for_mana == false then
			OnNotEnoughManaForAction()
			table.insert( discarded, action )
			return false -- <------------------------------------------ RETURNS
        else
            if(use_blood_for_mana == true) then
                local blood_mana_required = math.max(0.1, (action_mana_required / 10))
                if( take_blood_if_affordable(blood_mana_required) == false ) then
                    OnNotEnoughManaForAction()
                    table.insert( discarded, action )
                    return false  -- <------------------------------------------ RETURNS
                end
            elseif(use_gold_for_mana == true) then
                local gold_mana_required = math.max(1, (action_mana_required / 2))
                if( take_gold_if_affordable(gold_mana_required) == false ) then
                    OnNotEnoughManaForAction()
                    table.insert( discarded, action )
                    return false  -- <------------------------------------------ RETURNS
                end
            else
                mana = mana - action_mana_required
            end
        end
        
		
        
	end

	--- add the action to hand and execute it ---
	if action ~= nil then
		play_action( action )
	end

	return true
end